/*
** Dreamimage
** Copyright 2000 Richard Munn  <richard.munn@bigfoot.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** History:
** version 1.0 (6th June 2000) 
**  - First release to rvmu.port5.com
** version 1.01 (10th June 2000)
**  - Added GNU info to source and removed unneeded includes
*/

#include <stdio.h>

extern int optind;

void showhelp(char* argv[]){
  fprintf(stderr, "Usage: %s files...\n", argv[0]);
}

int isdiff(int* ch, int count){
  int x,y;

  for(x=0;x<count;x++)
    for(y=0;y<count;y++)
      if(x!=y)
        if(ch[x]!=ch[y])
          return 1;
  return 0;
}

int main(int argc, char *argv[]){
  int c,n,t,filecount,pos=0,okay,filesopen;
  FILE **file[10];
  int *ch[10];

  fprintf(stderr,"Easydiff v1.01 by Richard Munn <richard.munn@bigfoot.com>\n"); 

 while((c=getopt(argc, argv, "hb:f"))!=EOF)
    switch(c) {
     case 'h':
       showhelp(argv);
       return 0;
    }

  filecount = argc-1;

  if ((filecount<2)||(filecount>10)){
    printf("You must give between two and ten filenames\n");
    showhelp(argv);
    return 1;
  }

  t=0; okay=1;
  while((optind<argc)&&(okay==1)){
    printf("FL%d = %s\n",(t+1),argv[optind]);
    if((file[t]=fopen(argv[optind], "rb"))==NULL) {
      fprintf(stderr, "Failed to open \"%s\" for input.\n", argv[optind]);
      okay=0;
    }
    optind++; t++;
  }
  filesopen=t;

  if (okay==0){
    for(n=0;n<filesopen-1;n++)
      fclose(file[n]);
    return 1;
  }

  printf("\n");
  
  printf(" FPOS   ");
  for(n=0;n<filesopen;n++)
    printf("FL%x   ",n+1);

  printf("\n");

  okay=1; 

  while(okay==1){
    for(n=0;n<filesopen;n++)
      if ((ch[n]=fgetc(file[n]))==EOF)
        okay=0;

    if ((okay==1)&&(isdiff(ch,filesopen))){
      printf("$%4x   ",pos);

      for(n=0;n<filesopen;n++)
        printf("$%2x   ",ch[n]);

        printf("\n");
      }
    pos++;
  }

  for(n=0;n<filesopen;n++)
    fclose(file[n]);

  return 0;
}
